searchNodes=[{"doc":"Quarto (abbreviated Qto, 4to or 4º) is a book or pamphlet produced from full &quot;blanksheets&quot;, each of which is printed with eight pages of text, four to a side, then folded twice to produce four leaves. The leaves are then trimmed along the folds to produce eight book pages. Each printed page presents as one-fourth size of the full blanksheet. (https://en.wikipedia.org/wiki/Quarto)Quarto is a is a keyset-based pagination library for Ecto but confusingly the it is also referred to as cursor-based pagination. (Though cursor based pagination also means something else).In this case it means that the pagination relies on an opaque cursor to figure out where to start with the next batch of records. See https://use-the-index-luke.com/no-offsetThis library is ported from https://github.com/duffelhq/paginator/ but has some important backwards incompatible differences that warrant a new library.InstallationIf available in Hex, the package can be installed by adding quarto to your list of dependencies in mix.exs:def deps do [ {:quarto, &quot;~&gt; 1.0.0&quot;} ] endUsageYou can add Quarto to your Ecto.Repo. defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app use Quarto, limit: 10 endIt adds the paginate/3 function to your repository which you can use to paginate through a resultset. See Quarto.paginate/4 on the options that can be passed to use Quarto.To paginate you can query an Ecto schema like you normally would. It is important that the columns you order by are deterministically ordered. If there are null values in the columns or if two rows have the same values in the columns you order by the results may be wrong. To fix this you can always add an extra unique column to order by.The columns you order by will also be used to construct the opaque cursor that can be used to retrieve the next set of results.# First set of results %{entries: entries, metadata: metadata} = Post |&gt; order_by(desc: :user_id) |&gt; order_by({^order,:published_at}) |&gt; MyApp.Repo.paginate after_cursor = metadata.after # Next set of results %{entries: entries, metadata: metadata} = Post |&gt; order_by(desc: :user_id) |&gt; order_by({^order,:published_at}) |&gt; MyApp.Repo.paginate(after: after_cursor) # Get the before cursor before_cursor = metadata.before # Previous set of results %{entries: entries, metadata: metadata} = Post |&gt; order_by(desc: :user_id) |&gt; order_by({^order,:published_at}) |&gt; MyApp.Repo.paginate(before: before_cursor) %{entries: entries, metadata: metadata} = Post |&gt; order_by(desc: :user_id) |&gt; order_by({^order,:published_at}) |&gt; MyApp.Repo.paginate(include_total_count: true) # Total count of rows satisfying the query metadata.total_countAdvanced usageSome more advanced use cases are shown below.Without a macroIf you cannot use the macro in the repo you can still use Quarto.Quarto.Post |&gt; order_by(desc: :published_at) |&gt; Quarto.paginate([], MyApp.Repo)Simply call Quarto.paginate(queryable, opts, MyApp.Repo, repo_opts) with your repo as the third argument.Joining on related tablesIn addition to ordering by a field on the current table it's also possible to order on the field of a related table.E.g. in this example the ordering of the posts is by the name of the related user and the published_at date of the post.Quarto.Post |&gt; join(:left, [p], u in assoc(p, :user), as: :user) |&gt; preload([p, u], user: u) |&gt; order_by([p, u], desc: u.name) |&gt; order_by(desc: :published_at) |&gt; Repo.paginateWhat's important is that the preload function loads the user. This is necessary for when the cursor for the next result set is created as it needs the name of the user and the published_at of the post to create the new cursor.Passing in the cursorAlthough in normal usage the encoded cursor can be passed in. It's possible to use a normal erlang term as well.Quarto.Post |&gt; join(:left, [p], u in assoc(p, :user), as: :user) |&gt; preload([p, u], user: u) |&gt; order_by([p, u], desc: u.name) |&gt; order_by(desc: :id) |&gt; Repo.paginate(after: [&quot;Alice&quot;, 10])Implementing a custom cursorA default cursor implementation is provided but you can provide a custom implementation. E.g. to sign the cursors. The codec needs to implement the Quarto.Cursor behaviour. See Quarto.Cursor.Base64 for an exampleEncoding/decoding cursor valuesNormally a cursor is composed out of a list of values of one or more fields in the database. How each field is encoded/decoded depends on its type and can be controlled with the Quarto.Cursor.Decode and Quarto.Cursor.Encode protocols. See those modules for examples how you can override thisFragmentsEcto fragments provide ways to use custom SQL expressions in your ecto queries. Quarto does not support them in the order_by clause.NULL valuesNULL values in columns can be problematic for Quarto. Using coalescing it's possible to order by NULL values by coalescing them into a known value. E.g. when there are NULL values in a datetime column, the NULL values can be coalesced into the max or min datetime your database supports, depending on where you want them in your resultset.In the following example the title field has NULL values and therefore hard to order by. If we order alphabetically and asc and decide to place the rows with NULL values at the end we need to coalesce the NULL values to e.g. ZZZZZZZ. It's important that it's a value higher than any other in that column.coalesce = fn field, position, value -&gt; case field do :title -&gt; &quot;ZZZZZZZ&quot; _ -&gt; value end end Quarto.Post |&gt; order_by({:asc, :title}) |&gt; order_by({:asc, :position}) |&gt; MyApp.Repo.paginate(limit: 4, coalesce: coalesce) The field with the nameDocumentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/quarto.","ref":"Quarto.html","title":"Quarto","type":"module"},{"doc":"Build the cursor for a given entryIt's a helper function for taking the (nested) fields used for ordering and constructing the list that can be passed to the cursor encoder.In addition to this it's also possible to pass in the queryable used to generate the original query and cursors and derive the (nested) fields from that.Building the opaque cursor from the list cursor_for_entry/3 generates can be done by e.g. the Quarto.Cursor.Base64 module or any other module that implements the Quarto.Cursor behaviour.iex&gt; Quarto.cursor_for_entry(%User{id: 1}, :id) [1] iex&gt; Quarto.cursor_for_entry(%User{id: 1}, [:id, :name]) [1, nil] iex&gt; Quarto.cursor_for_entry(%User{id: 1, profile: %Profile{title: &quot;A profile&quot;}}, {:profile, :title}) [&quot;A profile&quot;] iex&gt; Quarto.cursor_for_entry(%User{id: 1, profile: %Profile{title: &quot;A profile&quot;}}, [[:profile, :title], :id]) [&quot;A profile&quot;, 1] iex&gt; Quarto.cursor_for_entry(%User{id: 1, profile: %Profile{title: &quot;A profile&quot;}}, [:id, {:profile, :title}]) [1, &quot;A profile&quot;] iex&gt; cursor = Quarto.cursor_for_entry(%Post{id: 2, user: %User{id: 1, profile: %Profile{title: &quot;A profile&quot;}}}, {:user, {:profile, :title}}) [&quot;A profile&quot;] iex&gt; Quarto.Cursor.Base64.encode!(cursor) &quot;g2wAAAABbQAAAAlBIHByb2ZpbGVq&quot; iex&gt; queryable = Post |&gt; order_by({:desc, :position}) iex&gt; Quarto.cursor_for_entry(%Post{id: 2, position: 3}, queryable) [3] iex&gt; queryable = Quarto.Post ...&gt; |&gt; join(:left, [p], u in assoc(p, :user), as: :user) ...&gt; |&gt; preload([p, u], user: u) ...&gt; |&gt; order_by([p, u], desc: u.name) ...&gt; |&gt; order_by({:desc, :position}) iex&gt; cursor = Quarto.cursor_for_entry(%Post{id: 2, position: 3, user: %User{name: &quot;A. Hamilton&quot;}}, queryable) [&quot;A. Hamilton&quot;, 3] iex&gt; Quarto.Cursor.Base64.encode!(cursor) &quot;g2wAAAACbQAAAAtBLiBIYW1pbHRvbmEDag==&quot;","ref":"Quarto.html#cursor_for_entry/3","title":"Quarto.cursor_for_entry/3","type":"function"},{"doc":"Paginate/4Fetches all the results matching the query within the cursors.Options:after - Fetch the records after this cursor.:before - Fetch the records before this cursor.:coalesce - Function that receives the field:cursor - Module to use for encoding/decoding the cursor:cursor_fields - Module to use for building the cursor from a record:include_total_count - Set this to true to return the total number of records matching the query. Note that this number will be capped by :total_count_limit. Defaults to false.:total_count_primary_key_field - Running count queries on specified column of the table:limit - Limits the number of records returned per page. Note that this number will be capped by :maximum_limit. Defaults to 50.:maximum_limit - Sets a maximum cap for :limit. This option can be useful when :limit is set dynamically (e.g from a URL param set by a user) but you still want to enfore a maximum. Defaults to 500.:total_count_limit - Running count queries on tables with a large number of records is expensive so it is capped by default. Can be set to :infinity in order to count all the records. Defaults to 10,000.Repo optionsThis will be passed directly to Ecto.Repo.all/2, as such any option supported by this function can be used here.","ref":"Quarto.html#paginate/4","title":"Quarto.paginate/4","type":"function"},{"doc":"Behaviour for custom encoding of cursor values.Used if you want finer control over how the values are encoded or decoded. Could be used to ensure the cursor are signed or validate cursors at your application boundaries.defmodule CustomCursor do @behaviour Quarto.Cursor ... end Quarto.Post |&gt; order_by(desc: :id) |&gt; Repo.paginate(cursor: CustomCursor)","ref":"Quarto.Cursor.html","title":"Quarto.Cursor","type":"behaviour"},{"doc":"Decodes a cursor binary.Returns an :ok tuple if it was able to decode the cursor, or else an :error tuple","ref":"Quarto.Cursor.html#c:decode/2","title":"Quarto.Cursor.decode/2","type":"callback"},{"doc":"Decodes a cursor binary.Returns the cursor or raises when it fails to decode","ref":"Quarto.Cursor.html#c:decode!/2","title":"Quarto.Cursor.decode!/2","type":"callback"},{"doc":"Encodes an erlang termReturns an :ok tuple if it was able to encode the cursor, or else an :error tuple","ref":"Quarto.Cursor.html#c:encode/2","title":"Quarto.Cursor.encode/2","type":"callback"},{"doc":"Encodes an erlang term.Returns the cursor or raises when it fails to encodes","ref":"Quarto.Cursor.html#c:encode!/2","title":"Quarto.Cursor.encode!/2","type":"callback"},{"doc":"Default cursor encoder/decoderWill encode any erlang term to base 64 and vice-versa.See also Quarto.Cursor.Encode for the protocol used to encode/decode individual values.","ref":"Quarto.Cursor.Base64.html","title":"Quarto.Cursor.Base64","type":"module"},{"doc":"See Quarto.Cursor.Encode","ref":"Quarto.Cursor.Decode.html","title":"Quarto.Cursor.Decode","type":"protocol"},{"doc":"Converts the binary to a single cursor term","ref":"Quarto.Cursor.Decode.html#convert/1","title":"Quarto.Cursor.Decode.convert/1","type":"function"},{"doc":"","ref":"Quarto.Cursor.Decode.html#t:t/0","title":"Quarto.Cursor.Decode.t/0","type":"type"},{"doc":"Protocol for encoding individual cursor values.E.g. some values are overly lengthy when encoding with the default way, implementing a custom protocol can cut that downdefimpl Quarto.Cursor.Encode, for: DateTime do def convert(term), do: {:dt, DateTime.to_unix(term, :microsecond)} end defimpl Quarto.Cursor.Decode, for: Tuple do def convert({:dt, unix_timestamp}), do: DateTime.from_unix!(unix_timestamp, :microsecond) endSee https://github.com/duffelhq/paginator/pull/62 for a helpful issue","ref":"Quarto.Cursor.Encode.html","title":"Quarto.Cursor.Encode","type":"protocol"},{"doc":"Converts the term to a single cursor value","ref":"Quarto.Cursor.Encode.html#convert/1","title":"Quarto.Cursor.Encode.convert/1","type":"function"},{"doc":"","ref":"Quarto.Cursor.Encode.html#t:t/0","title":"Quarto.Cursor.Encode.t/0","type":"type"},{"doc":"Module called to build the cursorReceives an entry, this will most likely be an Ecto struct. From the config it will derive the cursor fields and will fetch the value of those fields from the struct. It tries to chase down bindings to see if it can find the cursor field on related records.","ref":"Quarto.CursorValue.html","title":"Quarto.CursorValue","type":"module"},{"doc":"","ref":"Quarto.CursorValue.html#build/2","title":"Quarto.CursorValue.build/2","type":"function"},{"doc":"Derive the cursor fields from a given queryable","ref":"Quarto.Ecto.CursorFields.html","title":"Quarto.Ecto.CursorFields","type":"module"},{"doc":"build/2 accepts an Ecto.Query and inspects the Ecto AST to retrieve the fields the query will order by. These will be used to create the cursor.","ref":"Quarto.Ecto.CursorFields.html#build/2","title":"Quarto.Ecto.CursorFields.build/2","type":"function"},{"doc":"","ref":"Quarto.Ecto.CursorFields.html#t:direction/0","title":"Quarto.Ecto.CursorFields.direction/0","type":"type"},{"doc":"","ref":"Quarto.Ecto.CursorFields.html#t:field/0","title":"Quarto.Ecto.CursorFields.field/0","type":"type"},{"doc":"","ref":"Quarto.Ecto.CursorFields.html#t:position/0","title":"Quarto.Ecto.CursorFields.position/0","type":"type"},{"doc":"Defines a page.Fieldsentries - a list entries contained in this page.metadata - metadata attached to this page (see Quarto.Page.Metadata)","ref":"Quarto.Page.html","title":"Quarto.Page","type":"module"},{"doc":"","ref":"Quarto.Page.html#t:t/0","title":"Quarto.Page.t/0","type":"type"},{"doc":"Defines page metadata.Fieldsafter - an opaque cursor representing the last row of the current page.before - an opaque cursor representing the first row of the current page.limit - the maximum number of entries that can be contained in this page.total_count - the total number of entries matching the query.total_count_cap_exceeded - a boolean indicating whether the :total_count_limit was exceeded.","ref":"Quarto.Page.Metadata.html","title":"Quarto.Page.Metadata","type":"module"},{"doc":"","ref":"Quarto.Page.Metadata.html#t:opaque_cursor/0","title":"Quarto.Page.Metadata.opaque_cursor/0","type":"type"},{"doc":"","ref":"Quarto.Page.Metadata.html#t:t/0","title":"Quarto.Page.Metadata.t/0","type":"type"}]